function partTable = vyberRegulatoru(tabulka,pozadavek,pozadavek2,maxmin,pocetReg)
    disp('Probh vbr regultor')
    if(height(tabulka)>=pocetReg)
        
        maxValue = max(tabulka.(pozadavek))*1.01;
        minValue = min(tabulka.(pozadavek))*0.99;
        
        if(maxValue > 1e300)
            maxValue = 1e10;
            warning('Velmi velk hodnota v tabulce!')
        end
        
        rozdil = maxValue-minValue;
        skok = rozdil/pocetReg;
        rozsah = (minValue:skok:maxValue);
        

        
        
        indexes = zeros(1,pocetReg);
         
            for i = 1:pocetReg
                
                partTab = vyber(tabulka,pozadavek,rozsah(i),rozsah(i+1));
                
%                 [~, indKi] = max(partTab.Ki);
                if(maxmin == 'max')
                    [~,indKi] = max(partTab.(pozadavek2));   
                elseif (maxmin == 'min')
                    [~,indKi] = min(partTab.(pozadavek2));
                else
                    warning('patn zadan poadavek maxima/minima, dle se bere minimum')
                    [~,indKi] = min(partTab.(pozadavek2));
                end
                
                if(isempty(indKi))
                    warning(['Pozor, jeden z regultor nelze nalzt. Regultor . ' num2str(i)])
                    
                else
                    indexes(i) = indKi;
                    Tabs(i,:) = partTab(indKi,:);
                end
            end
            
            
            nevhodny = zeros(1,height(Tabs));
            for i = 1:height(Tabs)
                
                if(Tabs.Kp(i) < 1e-100 && Tabs.Ki(i) < 1e-100)
                    Tabs.Kp(i) = -Inf;
                   nevhodny(i) = 1; 
                end
            end
            
            %disp('Tady jsem')
            if(max(nevhodny) > 0)
                answer = questdlg('Chcete odstranit przdn dky z tabulky?', ...
                'Przdn dky', ...
                'Ano','Ne','Ne');
                if(strcmp(answer,'Ano'))
                    Tabs = vyber(Tabs,'Kp',0,inf);
                    Tabs = sortrows(Tabs,pozadavek,'ascend');
                    
                end
            end
            
            
            
            
            
            
            
            
            %parts = partTab;
            partTable = Tabs;
    else
        partTable = table();
        warning('Nedostatek dk tabulky!!')
    end
end