
function [hranicniBody, Region] = vypocetRegionu(plant,Ms,paralerni_vypocty,viceRegionu)
tic
    Ts = plant.Ts;
    %plant = Pcd;
%      krok = 0.15;
% 
%      krok = 0.5;
%      ws = 1e-8:krok:2000;


    %[frek_charka, ws] = freqresp(plant,ws);

    [frek_charka, ws] = freqresp(plant);


    As = squeeze(real(frek_charka(1,1,1:end)));
    Bs = squeeze(imag(frek_charka(1,1,1:end)));

    % A1s = gradient(As,krok);
    % B1s = gradient(Bs,krok);
    A1s = gradient(As,ws);
    B1s = gradient(Bs,ws);


    % Kis = cell(4,1);
    %     Kps = cell(4,1);
    %     Ks = ones(4,1);


    %6)for i to N
    pocetBodu = 0;
    Kis = inf*ones(1,4*length(ws));
    Kps = inf*ones(1,4*length(ws));

    for i = 1:length(ws)


        %7) A = A(i) B = B(i) atd..
        A = As(i);
        B = Bs(i);
        A1 = A1s(i);
        B1 = B1s(i);
        w = ws(i);


        %8) compute the coeff a,b,c,d,e
        a = (A^2+B^2)^4;

        b = 2*Ms*((A^2+B^2)^2)*(-w*B1*A^2+2*w*B*A*A1+w*B^2*B1+B*A^2+B^3); 

        c = -(A^2+B^2)*(2*w*A1*A^3+4*A^2*Ms^2*w*B*B1+2*A^2*w*B*B1-A^2*w^2*B1^2*Ms^2-w^2*Ms^2*A^2*A1^2-Ms^2*B^2*A^2-8*A*w*Ms^2*B^2*A1+2*A*w*A1*B^2-w^2*A1^2*Ms^2*B^2-B^4*Ms^2+2*w*B1*B^3-w^2*Ms^2*B^2*B1^2-4*B^3*Ms^2*w*B1);

        d = -2*w*Ms*(-Ms^2*w*A1^2*B^3-Ms^2*w*B*A^2*A1^2-2*Ms^2*B^3*A*A1-Ms^2*w*B1^2*A^2*B+Ms^2*B^2*A^2*B1-Ms^2*B^4*B1-Ms^2*w*B1^2*B^3+3*w*B1*B^2*A*A1-w*B1^2*A^2*B+B^3*A*A1+2*w*B*A^2*A1^2+w*B1^2*B^3-w*B1*A^3*A1+B^2*A^2*B1+B*A^3*A1+B^4*B1);

        e = -w^2*(Ms-1)*(Ms+1)*(-A1^2*Ms^2*B^2-Ms^2*B^2*B1^2+2*B*B1*A*A1+B^2*B1^2+A^2*A1^2);

        pokus = [a b c d e];
        vysledekMat = roots(pokus);
        for ii = 1:length(vysledekMat)
           if((abs(imag(vysledekMat(ii)))<1e-15)) 
                pocetBodu = pocetBodu +1; 
                hraniceReg = vysledekMat(ii);
                Kis(pocetBodu) = (hraniceReg*w)/Ms;
                Kps(pocetBodu) = -1/((w*Ms^2*(2*A*B*B1+A^2*A1-A1*B^2))/(hraniceReg^2*(A^2+B^2)^2+hraniceReg*Ms*(w*(-B1*A^2+2*B*A1*A+B^2*B1)+B*(A^2+B^2))+w*(Ms^2-1)*(B*B1+A*A1)));

           end
        end

    end

    Kis = Kis(1:pocetBodu);
    Kps = Kps(1:pocetBodu);

    Kis = [0 1 Kis];
    Kps = [1 0 Kps];
%    scatter(Kis,Kps)
    
%     figure;
%     scatter(Kis,Kps);
%     title('vechny hranice')

%     if(plant.Ts>0)
%         plantC = d2c(plant);
%     else
%         plantC = plant;
%     end

    KiStable = inf*ones(1,length(Kis));
    KpStable = inf*ones(1,length(Kis));



    w = waitbar(0,'Hledani stabilni hranice');
            D = parallel.pool.DataQueue;
            afterEach(D,@parforWaitbar);


            parforWaitbar(w,length(Kis))


    if(paralerni_vypocty == false)
        for i = 1:length(Kis)
            send(D,i);
            if(Kis(i) >= 0 && Kps(i) >= 0)
                %Kis(i)
                %Kps(i)
                PI = tf([Kps(i) Kis(i)],[1 0]);
                if(Ts>0)
                    PI = c2d(PI,Ts,'Tustin');
                end
                T = feedback(PI*plant,1);
                S = feedback(1,PI*plant);
                if isstable(T)==1 && norm(S,inf) < Ms*1.05
                    KiStable(i)=Kis(i);
                    KpStable(i)=Kps(i);
                end
            end
        end        
        
    else
        
        parfor i = 1:length(Kis)
            send(D,i);
            if(Kis(i) >= 0 && Kps(i) >= 0)
                PI = tf([Kps(i) Kis(i)],[1 0]);
                                
               if(Ts>0)
                    PI = c2d(PI,Ts,'Tustin');
                end
                T = feedback(PI*plant,1);
                S = feedback(1,PI*plant);
                if isstable(T)==1 && norm(S,inf) < Ms*1.05
                    KiStable(i)=Kis(i);
                    KpStable(i)=Kps(i);
                end
            end
        end  
    end
    delete(w)
    %KiStable
    %KpStable
    KiStable = KiStable(~isinf(KiStable));
    KpStable = KpStable(~isinf(KpStable));


    
%      figure;
%      scatter(KiStable,KpStable);
%      title('Stabiln hranice');

    disp('Dokonen hledn stabiln hranice');
    

    
    
    
    
    
    indexRozdeleni = 0;
    if(viceRegionu == true)
        indexRozdeleni = overPocetRegionu(KpStable);
    end
    
    if(indexRozdeleni > 0)
        [hranicniBody{1},Region{1}] = dopocitejRegion([KiStable(1:indexRozdeleni)',KpStable(1:indexRozdeleni)'],Ms,plant,paralerni_vypocty);
        [hranicniBody{2},Region{2}] = dopocitejRegion([KiStable(indexRozdeleni+1:end)',KpStable(1+indexRozdeleni:end)'],Ms,plant,paralerni_vypocty);
    else
        [hranicniBody{1},Region{1}] = dopocitejRegion([KiStable',KpStable'],Ms,plant,paralerni_vypocty);
    end
    
    
   
 
    
    
    
    
    
    
    
   
   
    function index = overPocetRegionu(KpStable)
        Kps = [KpStable',(1:length(KpStable))'];
        KpsSorted = sort(Kps,'ascend');

        suma = 0;
        rozdily = ones(1,length(KpsSorted)-1);
        index = 0;
        for i = 1:length(KpsSorted)-1
           %spocitej rozdily
           rozdily(i) = abs(KpsSorted(i)-KpsSorted(i+1)); 
           if(5*suma<rozdily(i) && i>3)
               index = i;
           end
           suma = suma+rozdily(i);
        end
    
    end
end