function vytvorGrafy(tabulka,spolCast,motor,zatez)
    if (~exist('motor', 'var'))
        motor = 1;
    end
    
    if (~exist('zatez', 'var'))
        zatez = 1;
    end
    

    
    
    
    disp('Tvo se grafy vybranch regultor')
    Ts = spolCast.Ts;
    for i = 1:height(tabulka)
        
        if(Ts>0)
            PIc = (tf([tabulka.Kp(i) tabulka.Ki(i)],[1 0]));
            PI(i) = c2d(PIc,Ts,'Tustin');
        else
            PI(i) = (tf([tabulka.Kp(i) tabulka.Ki(i)],[1 0]));
        end
        
        Tm(i) = feedback(PI(i)*spolCast*motor,1);
        Tl(i) = feedback(PI(i)*spolCast,motor)*zatez;
        Psm(i) = feedback(spolCast*motor,PI(i));
        Psl(i) = feedback(spolCast,motor*PI(i))*zatez;
        
        %tabulka
%         Ts = motor.Ts;
%         %Psm
%         t = (0:Ts:3)';
%         
%         y = step(Psm(i),t);
%         error = 1-y;
%         pokus = trapz(t, t.*abs(error))
%         %size(y)
%         %size(t.*abs(error))
%              
%         y = step(Psl(i),t);
%         error = 1-y;
%         pokus2 =  trapz(t, t.*abs(error))
        
    end
    for i=1:height(tabulka)
       disp(['Tvo se: ' num2str(i) '. graf z ' num2str(height(tabulka))])
       figure
       %titulek = ['Kp =' num2str(tabulka.Kp(i)) '  Ki = ' num2str(tabulka.Ki(i)) ' ' pozadavek ' = ' num2str(tabulka.(pozadavek)(i)) ' ' pozadavek2 ' = ' num2str(tabulka.(pozadavek2)(i))];
       titulek = ['Kp =' num2str(tabulka.Kp(i)) '  Ki = ' num2str(tabulka.Ki(i))];
      
        
       %sgtitle(titulek,'interpreter','none')
       sgtitle(titulek)

       subplot(1,12,1:4)
       step(Psm(i));
       %step(Psm(i));
       hold on
       step(Psl(i));
       
%        text(0.5,0.85,(['g_m = ' num2str(tabulka.Gm(i),2)]),'Units','normalized')
%        text(0.5,0.77,(['p_m = ' num2str(tabulka.Pm(i),2)]),'Units','normalized')
%        text(0.5,0.69,(['s_m = ' num2str(tabulka.sm(i),2)]),'Units','normalized')
%        text(0.5,0.61,(['M_{tl} = ' num2str(tabulka.Mt_Tl(i),2)]),'Units','normalized')
%        text(0.5,0.54,(['\omega_b = ' num2str(tabulka.sirka_pasma_T(i),2)]),'Units','normalized')
       
       legend({'vstupni porucha motor','vstupni porucha zatez'},'Location','best')
       
       ax = subplot(1,12,5:8);
       nazvy = tabulka.Properties.VariableNames;
       for ii = 1:width(tabulka)
           string = [nazvy{ii} ' = ' num2str(tabulka.(nazvy{ii})(i),2)];
           text(0.01,1.05-0.05*ii,string,'interpreter','none');

           
       end
       set ( ax, 'visible', 'off')
       %set(ax,'InvertHardCopy','off','Color','white');
       
       subplot(1,12,9:12)
       step(Tm(i))
       hold on
       step(Tl(i))
       %legend({'pechod motor','pechod zatez'},'Location','northoutside')
       legend({'pechod motor','pechod zatez'},'Location','northeast')
       
       %[y,t] = step(Tl(i));
       %y(end)
%        text(0.5,0.48,(['ITAE = ' num2str(tabulka.ITAE(i),2)]),'Units','normalized')
%        text(0.5,0.40,(['IAE = ' num2str(tabulka.IAE(i),2)]),'Units','normalized')
%        text(0.5,0.32,(['ISE = ' num2str(tabulka.ISE(i),2)]),'Units','normalized')
%        text(0.5,0.24,(['ITAE_l = ' num2str(tabulka.ITAE_Tl(i),2)]),'Units','normalized')
%        text(0.5,0.16,(['IAE_l = ' num2str(tabulka.IAE_Tl(i),2)]),'Units','normalized')
%        text(0.5,0.08,(['ISE_l = ' num2str(tabulka.ISE_Tl(i),2)]),'Units','normalized')
       
       
       
    end
    %legend('1','2','3','4','5')
    %legend([num2str(Kp(1)) ' ' num2str(Ki(1))],[num2str(Kp(2)) ' ' num2str(Ki(2))],[num2str(Kp(3)) ' ' num2str(Ki(3))],[num2str(Kp(4)) ' ' num2str(Ki(4))],[num2str(Kp(5)) ' ' num2str(Ki(5))])
end