function [Kis,Kps] = vytvorPrunik(Regiony, pocet_bodu) 
    

    %pocet_bodu = 20000;
    pocet_bodu_na_ose = round(sqrt(pocet_bodu));
    krok = 1/(pocet_bodu_na_ose-1);


    k = 1;
    mrizkaKi = zeros(1,pocet_bodu_na_ose);
    mrizkaKp = zeros(1,pocet_bodu_na_ose);
    for i = 0:krok:1
        for j = 0:krok:1
            mrizkaKi(k) = i;
            mrizkaKp(k) = j;
            k = k+1;
        end
    end
    
    Ki = Regiony{1}(:,1)';
    Kp = Regiony{1}(:,2)';
    for i = 2:length(Regiony)
       Ki = [Ki Regiony{i}(:,1)'];
       Kp = [Kp Regiony{i}(:,2)']; 
    end
    
    maxKi = max(Ki);
    minKi = min(Ki);
    maxKp = max(Kp);
    minKp = min(Kp);

    
    Kis = NaN*ones(1,length(mrizkaKi));
    Kps = NaN*ones(1,length(mrizkaKi));
    
    for i = 1:length(mrizkaKi)
        origKi = minKi + mrizkaKi(i).*(maxKi - minKi);
        origKp = minKp + mrizkaKp(i).*(maxKp - minKp);
        %vPrvnim = inpolygon(origKi,origKp,Region(:,1),Region(:,2));
        %vDruhem = inpolygon(origKi,origKp,Region2(:,1),Region2(:,2));
        vRegionu = zeros(1,length(Regiony));
        for ii = 1:length(Regiony)
           if(inpolygon(origKi,origKp,Regiony{ii}(:,1),Regiony{ii}(:,2))) 
                vRegionu(ii) = 1;
           end
        end
        
        if(min(vRegionu))
            Kis(i) = origKi; 
            Kps(i) = origKp;
        end
    end
    
    Kps = Kps(~isnan(Kps));
    Kis = Kis(~isnan(Kis));
    end