tic
%r = 1.1;
r = 2;
%r = 6;


%prenos systemu:
Ts = 0.0005;
Ti = tf([0 3770 1.316e07],[0.33333 3771 1.316e07]);
Tm = 0.05;
Pmcc = tf([0 1],[Tm 1]);

Tf = 0.001;
Pf = tf([0 1],[Tf 1]);
xiz = 0.005;
wz = 20*2*pi;


Pr = tf([1 2*xiz*wz wz^2]*r^2,[1 2*xiz*wz*r^2 wz^2*r^2]);
Pr2 = tf([0 2*xiz*wz wz^2]*r^2,[1 2*xiz*wz*r^2 wz^2*r^2]);
%%
Pmd = c2d(Pmcc,Ts);
Pfd = c2d(Pf,Ts);
Tid = c2d(Ti,Ts);
Prd = c2d(Pr,Ts);
Prd2 = c2d(Pr2,Ts);


Pmd = ss(Pmd);
Pfd = ss(Pfd);
Tid = ss(Tid);
Prd = ss(Prd);
Prd2 = ss(Prd2);
%Pc2 =Pf*Ti*Pm*Pr2;
Pcd2 = c2d(Pr2,Ts);

Pc = Pf*Ti*Pmcc*Pr;


%Pcd = c2d(Pc,Ts);
spolCast = Pfd*Tid*Pmd;

P=tf([0 0 0.0289 0.34 1],[0.028 1.056 2.028 1 0]);

integ = tf([0 1],[1 0]);
integd = c2d(integ,Ts);

tic
paralerni_vypocty = false;
%%
%4 zakladni, all, reference, porucha, refPor a pak jednotlive indexy (sm, gm, pm, Ms, Mt, Mt_Tl, sirka_T, ITAE, IAE, ISE, ITE_Tl, IAE_Tl, ISE_Tl, ITAE_PS, IAE_PS, ISE_PS, ITAE_Tl_PS, IAE_Tl_PS, ISE_Tl_PS )
%celkem 23 moznosti!!
%all znamena vsech 23 indexu
%reference znamena ITAE-ISE,ITAE_Tl-ISE_Tl
%porcuha znamena ITAE_PS-ISE_PS,ITAE_Tl_PS-ISE_Tl_PS
%refPor znamena reference+porucha!
indexy = ["all"];

Ms = 2;
% pozadavek1 = 'sirka_T';
% pozadavek2 = 'IAE_Tl_PS'; %nvrh soustav, pouzij Mt a ITAE

[hranicniBody, reg] = vypocetRegionu(spolCast*Prd,Ms,paralerni_vypocty,true);
%Kp =3.00   Ki = 90.6
Region = hranicniBody{1};


Tabulka = vytvorTabulku(Region,Ms,paralerni_vypocty,spolCast,Prd,Prd2,indexy,4000);
%Tabulka = vytvorTabulku(Region,Ms,true,spolCast,Prd,Prd2,20000);


%%

Vyber = Tabulka;
%Vyber = vyber(Tabulka,'Ki',1e-25,inf);
%Vyber = vyber(Vyber,'Pm',30,1e100);
pozadavek1 = 'soucetIAE';
pozadavek2 = 'soucetIAE';
Vyber.soucetITAE = Vyber.ITAE+Vyber.ITAE_Tl+Vyber.ITAE_PS+Vyber.ITAE_Tl_PS;
Vyber.soucetIAE = Vyber.IAE+Vyber.IAE_Tl+Vyber.IAE_PS+Vyber.IAE_Tl_PS;
Vyber = vyber(Vyber,'Pm',45,inf);
Vyber = vyber(Vyber,'sm',0.5,inf);
Vyber = vyber(Vyber,'Gm',2,inf);
Vyber = vyberRegulatoru(Vyber,pozadavek1,pozadavek2,'min',1);

vytvorGrafy(Vyber,spolCast,Prd,Prd2)

toc

%%
vrstevnice(Tabulka,'ITAE')
%%
graf3D(Tabulka,pozadavek1)
toc
%%
interaktivniRegion(Tabulka,spolCast,Prd,Prd2)


%%  navrh PD

%PIv = tf([2.5 100],[1 0]);
%Tv = feedback(c2d(PIv,Ts)*spolCast*Prd,1);
%S = feedback(1,c2d(PIv,Ts)*spolCast*Prd);%(*spolCast*Prd));

Tv = feedback(PI*spolCast*Prd,1);
S = feedback(1,PI*spolCast*Prd);%(*spolCast*Prd));

step(Tv)
norm(S,inf)
%%
PIvd = c2d(PIv,Ts);
spolCastPol = feedback(PIvd*spolCast,Prd);

[hranicniBody, reg] = vypocetRegionu((Tv),Ms,paralerni_vypocty,false);

Region = hranicniBody{1};
figure;
scatter(Region(:,1),Region(:,2))
%%
Tabulka = vytvorTabulku(Region,Ms,paralerni_vypocty,spolCastPol,Prd,Prd2,indexy,4000);

%Vyber = vyber(Tabulka,'Ki',0,1e-20);
Vyber = vyberRegulatoru(Vyber,pozadavek1,pozadavek2,'max',10);
%%
vytvorGrafy(Vyber,spolCastPol,Prd,Prd2);

%% oveen PD
P = 55;
D = 1;

prenosD = tf([1 0],[0 1]);

prenosD = c2d(prenosD,Ts,'Tustin');
Tvc = d2c(Tv); 
Fd = feedback(Tv*integd,prenosD);
Tpd = feedback(Fd*P,1);
step(Tpd)
hold on
step(feedback(P*Tv*integd,1));
%% TO-DO list





%%
% C = tf([0.5993 138.64],[0 1]);
% pokus1 = feedback(C*d2c(Tv)*tf([1],[1 0]),1);
% pokus1 = c2d(pokus1,Ts);
% figure
% step(pokus1);

%%
% function vytvorGrafPres(tabulka,spolCast,motor,zatez,spolCastZat)
% if (~exist('graf', 'var') || ~isvalid(graf))
%         graf = figure();
% end
% figure(graf)
% 
% if (~exist('motor', 'var'))
%     motor = 1;
% end
%     
% if (~exist('zatez', 'var'))
%     zatez = 1;
% end
% 
% if (~exist('spolCastZat', 'var'))
%     spolCastZat = spolCast;
% end
    


% leg = legend();
% if (~isempty(leg.String))
%         graf = figure();
% end
% Ts = Prd.Ts;
% i = 1;
% if(Ts>0)
%         PIc = (tf([tabulka.Kp(i) tabulka.Ki(i)],[1 0]));
%         PI(i) = c2d(PIc,Ts);
% else
%             PI(i) = (tf([tabulka.Kp(i) tabulka.Ki(i)],[1 0]));
% end
%         
%         Tm(i) = feedback(PI(i)*spolCast*motor,1);
%         Tl(i) = feedback(PI(i)*spolCastZat,motor)*zatez;
%         Psm(i) = feedback(spolCast*motor,PI(i));
%         Psl(i) = feedback(spolCastZat,motor*PI(i))*zatez;
% 
% 
% subplot(2,2,1)
% step(Tm)
% hold on
% title('Pechodov charakteristika u motoru')
% xlabel('Ki')
% ylabel('Kp')
% 
% subplot(2,2,2)
% step(Psm)
% hold on
% title('Odezva na poruchu u motoru')
% xlabel('Ki')
% ylabel('Kp')
% 
% 
% subplot(2,2,3)
% step(Tl)
% hold on
% title('Pechodov charakteristika u zte')
% xlabel('Ki')
% ylabel('Kp')
% 
% subplot(2,2,4)
% step(Psl)
% hold on
% title('Odezva na poruchu u zte')
% xlabel('Ki')
% ylabel('Kp')
% 
% end
% % legend()



% function vytvorGraf(Tabulka)
%     figure
%     scatter(Tabulka.Ki,Tabulka.Kp);
% 
% end


% hranicniBody = vypocetRegionu(P,Ms,false,true);
% Region = hranicniBody{1};
% Tabulka = vytvorTabulku(Region,Ms_orig,paralerni_vypocty,P,4000);
% Vyber = vyberRegulatoru(Tabulka,pozadavek1,'IAE_Tl','min',5);
% 
% vytvorGrafy(Vyber,pozadavek1,P)




%%Popis funkc!!
% 1.[hranicniBody,Region] = dopocitejRegion(hranicniBody,Ms,plant,paralerni_vypocty) - pomocna fce, pro vypocetRegionu
%     funkce zpresnuje hranice regionu
%     vstupy:     
%         - hranicniBody od vypoctuRegionu
%         - zadane Ms
%         - prenos systemu, otevrena smycka
%         - paralerni_vypocty == true, pobezi paralerne, jinak ne
%     vystupy:    
%         -hranicniBody - hranice regionu
%         -Region - namrizkovany region o max 600 bodech
% 
% 2. [hranicniBody, Region] = vypocetRegionu(plant,Ms,paralerni_vypocty,viceRegionu)
%     funkce vypocita region, najde jeho hranice
%     vstupy:
%         - plant - prenos systemu, otevrena smycka
%         - pozadovane Ms
%         - paralerni_vypocty pro paralerismus
%         - viceRegionu - true/false, zkusi najit 2. region, experimentalni verze!
%     vystupy:
%         - hranicniBody - hranice regionu
%         - Region - namrizkovany region, vraci max 600 bodu
% 
% 3. Tabulka = vytvorTabulku(Region,Ms_orig,paralerni_vypocty,spolCast,Prd,Prd2,pocet_bodu)
%     funkce vytvori tabulku s regulatory v regionu
%     vstupy:
%         - Region - zde se zada region pripadne jeho hranice
%         - pozadovane Ms
%         - paralerni vypocty true/false
%         - spolCast/tuhy system - zde se zadava spolecna cast pro oba dva prenosy
%         - Prd - volitelne - kmitavy prenos na strane motoru
%         - Prd2 - volitelne - kmitavy prenos na strane zateze
%         - pocet_bodu - vollitelne, defaultne 4000, urcuje pocet bodu v mrizce, nikoliv pocet regulatoru
%     vystup:
%         -Tabulka, vraci tabulku vdy o velikosti (neco,15), pokud jde o tuhy system, 
%                   tak 'ITAE' = 'ITAE_Tl' a obdobne i pro vsechny ostatni parametry
% 
% 4. partTable = vyberRegulatoru(tabulka,pozadavek,pozadavek2,maxmin,pocetReg)                  
%     funkce vybere zadany pocet regulatoru podle pozadavku
%     vstupy:
%         - tabulka, ze ktere se vybiraji regulatory
%         - pozadavek podle ktereho se tabulka rozdeli
%         - pozadavek2 podle toho se vybira regulatoru v rozdelenem intervalu
%         - maxmin - zde se zada 'max', nebo 'min' podle toho, 
%             zda se ma regulator vybrat s nejmensim nebo nejvetsim pozadavkem2
%         -pocetReg - pocetRegulatoru, ktere se maji vybrat
%     vystup:
%         -partTable - tabulka s danm poctem regulatoru
%         
% 5. vytvorGrafy(tabulka,pozadavek,pozadavek2,spolCast,motor,zatez)
%     funkce vytvori grafy z vybranych regulatoru
%     vstupy:
%         - tabulka, ze ktere se tvori grafy
%         - pozadavek podle ktereho byla vytvorena tabulka
%         - pozadavek2 - druhotny pozadavek
%         - spolCast - spolecna cast systemu/tuhy system
%         - motor - voitelny, kmitavy prenos u motoru
%         - zatez - volitelny, kmitavy prenos u zateze
% 
% 6. parforWaitbar(waitbarHandle,iterations)
%     funkce tvorici waitbary, z matlab dokumentace, pomocna
%     
% 7. Tab = vyber(tabulka, pozadavek, jednaHod , druhaHod)
%     fce vybere radky splnujici rozmezi pro nejaky pozadavek
%     vstupy:
%         - tabulka, ze ktere se vybiraji radky
%         - pozadavek podle ktereho se vybira
%         - jednaHod, jedna krajni hodnota
%         - druhaHod, druha krajni hodnota
%     vystup:
%         Tab, tabulka s vybranymi radky
%         
% 8. vrstevnice(tabulka,pozadavek)
%     fce vytvori graf s vrstevnicemi pro dany pozadavek
%     vstupy:
%         - tabulka, ze ktere se vybira
%         - pozadavek, podle ktereho se vybira
%     
% 9. graf3D(tabulka,pozadavek)
%     fce ktera vytvori 3D graf
%     vstupy:
%         - tabulka ze ktere se tvori, Kp, Ki tvori X a Y
%         - pozadavek, tvori souradnici Z
    
       
            
        
        
       









