function [hranicniBody,Region] = dopocitejRegion(hranicniBody,Ms,plant,paralerni_vypocty)
     
    maxKol = 10;
    aktualniKolo = 0;

    Kis = hranicniBody(:,1);
    Kps = hranicniBody(:,2);
    
    Ts = plant.Ts;

    %Kis
    
    minKi = min(Kis);
    %min(Kis)
    if(minKi<0)
        minKi = 0;
    end
    maxKi = max(Kis);

    minKp = min(Kps);
    if(minKp<0)
        minKp = 0;
    end
    maxKp = max(Kps);
    pocet_vzorku = 49;
    pocet_bod_na_ose = round(sqrt(pocet_vzorku));
    krok = 1/(pocet_bod_na_ose-1);

    
    
    disp('Zan hrub hledn regionu:')

    % figure;
    Ki = 1;
    
    w = waitbar(0,'Upesovn hranice regionu');
            D = parallel.pool.DataQueue;
            afterEach(D,@parforWaitbar);


            parforWaitbar(w,maxKol*pocet_vzorku)
    
    
    while(maxKol > aktualniKolo )%&& length(Ki) < 0.8*pocet_vzorku)
        %send(D,aktualniKolo);
        aktualniKolo = aktualniKolo+1;
        %disp(['Zan ' num2str(aktualniKolo) '|' num2str(maxKol) '. cyklu.'])

        if(aktualniKolo >1)
            prevMinKi = minKi;
            prevMaxKi = maxKi;
            prevMinKp = minKp;
            prevMaxKp = maxKp;

    %         if(prevMaxKp < maxKp)
    %             maxKp = maxKp*1.5;
    %         else
    %             maxKp = max(Kp)+(prevMaxKp/(pocet_bodu_na_ose)); 
    %         end
                minKi = min(Ki)-abs(prevMinKi/(pocet_bod_na_ose)) ;
                if(minKi<0)
                    minKi = 0;
                end
                maxKi = max(Ki)+(prevMaxKi/(pocet_bod_na_ose));
                    
                
                minKp = min(Kp)-abs(prevMinKp/(pocet_bod_na_ose));
                if(minKp<0)
                    minKp = 0;
                end
%                 if(aktualniKolo==2)
%                     Kp
%                 end
                maxKp = max(Kp)+(prevMaxKp/(pocet_bod_na_ose));

        end


%         norm_dataKi = (Kis - minKi) / ( maxKi - minKi );
%         norm_dataKp = (Kps - minKp) / ( maxKp - minKp );


        k = 1;
        mrizkaKi = zeros(1,pocet_bod_na_ose);
        mrizkaKp = zeros(1,pocet_bod_na_ose);
        for i = 0:krok:1
            for j = 0:krok:1
                mrizkaKi(k) = i;
                mrizkaKp(k) = j;
                k = k+1;
            end
        end
        

        %pocetReg = 0;
        Kp = inf*ones(1,length(mrizkaKi));
        Ki = inf*ones(1,length(mrizkaKi));
        
        KpNe = inf*ones(1,length(mrizkaKi));
        KiNe = inf*ones(1,length(mrizkaKi));

        
        if(paralerni_vypocty == false)
            for i = 1:length(mrizkaKi)
                
                send(D,i);
                origKi = minKi + mrizkaKi(i).*(maxKi - minKi);
                origKp = minKp + mrizkaKp(i).*(maxKp - minKp);
%                  minKp
%                  mrizkaKp(i)
%                  maxKp
                %minKps
                PI = tf([origKp origKi],[1 0]);
        %         T = feedback(plant*PI,1);
        %         S = feedback(1,plant*PI);
                if(plant.Ts)>0
                   PI = c2d(PI,plant.Ts,'Tustin');
                end
        
                T = feedback(plant*PI,1);
                S = feedback(1,plant*PI);
                
                if (isstable(T)) == 1 && norm(S,inf)< Ms*1.1
                    
                    %pocetReg = pocetReg+1;
                    %size(Kp)
                    %size(origKp)
                    %origKp
                    Kp(i) = origKp;
                    Ki(i) = origKi;
                else
                    if(aktualniKolo == 10)
                        KiNe(i) = origKi;
                        KpNe(i) = origKp;
                    end
                    
                end

            end

        else
            
            parfor i = 1:length(mrizkaKi)
                send(D,i);
                origKi = minKi + mrizkaKi(i).*(maxKi - minKi);
                origKp = minKp + mrizkaKp(i).*(maxKp - minKp);
%                  minKp
%                  mrizkaKp(i)
%                  maxKp
                %minKps
                PI = tf([origKp origKi],[1 0]);
        %         T = feedback(plant*PI,1);
        %         S = feedback(1,plant*PI);
                if(Ts>0)
                   PI = c2d(PI,Ts,'Tustin');
                end
        
                T = feedback(plant*PI,1);
                S = feedback(1,plant*PI);
                
                if (isstable(T)) == 1 && norm(S,inf)< Ms*1.1
                    
                    %pocetReg = pocetReg+1;
                    %size(Kp)
                    %size(origKp)
                    %origKp
                    Kp(i) = origKp;
                    Ki(i) = origKi;
                end

            end
            
            
            
            
        end
        
        
        Ki = Ki(~isinf(Ki));
        Kp = Kp(~isinf(Kp));

        KiNe = KiNe(~isinf(KiNe));
        KpNe = KpNe(~isinf(KpNe));
        

        
    end
    
%         size(Ki)
%         size(KiNe)
%         size(Kp)
%         size(KpNe)
    
    delete(w)
    
%         figure
%         scatter(Ki,Kp,30,'b','filled')
%         hold on
%         scatter(KiNe,KpNe,30,'r','filled')
%         title('Hrub nalezen region')
%         xlabel('K_i')
%         ylabel('K_p')
%         legend('Body regionu','Okoln body')
    
    minKi = min(Ki);
    %min(Kis)
    if(minKi<0)
        minKi = 0;
    end
    maxKi = max(Ki);

    minKp = min(Kp);
    if(minKp<0)
        minKp = 0;
    end
    maxKp = max(Kp);
    pocet_vzorku = 600;
    pocet_bod_na_ose = round(sqrt(pocet_vzorku));
    krok = 1/(pocet_bod_na_ose-1);
    
    k = 1;
        mrizkaKi = zeros(1,pocet_bod_na_ose);
        mrizkaKp = zeros(1,pocet_bod_na_ose);
        for i = 0:krok:1
            for j = 0:krok:1
                mrizkaKi(k) = i;
                mrizkaKp(k) = j;
                k = k+1;
            end
        end
   
        w = waitbar(0,'Zjemovn regionu');
            D = parallel.pool.DataQueue;
            afterEach(D,@parforWaitbar);


            parforWaitbar(w,length(mrizkaKi))
        
        
        Kp = inf*ones(1,length(mrizkaKi));
        Ki = inf*ones(1,length(mrizkaKi));

        if(paralerni_vypocty == false)
            
            for i = 1:length(mrizkaKi)
                send(D,i);
                origKi = minKi + mrizkaKi(i).*(maxKi - minKi);
                origKp = minKp + mrizkaKp(i).*(maxKp - minKp);
                %origKi
%                 minKp
%                 mrizkaKp(i)
%                 maxKp
                %minKps
                PI = tf([origKp origKi],[1 0]);
        %         T = feedback(plant*PI,1);
        %         S = feedback(1,plant*PI);
                if(plant.Ts)>0
                   PI = c2d(PI,plant.Ts,'Tustin');
                end
        
                T = feedback(plant*PI,1);
                S = feedback(1,plant*PI);
                if (isstable(T)) == 1 && norm(S,inf)< Ms*1.01
                    
                    %pocetReg = pocetReg+1;
                    %size(Kp)
                    %size(origKp)
                    %origKp
                    Kp(i) = origKp;
                    Ki(i) = origKi;
                end

            end
            
        else
            parfor i = 1:length(mrizkaKi)
                send(D,i);
                origKi = minKi + mrizkaKi(i).*(maxKi - minKi);
                origKp = minKp + mrizkaKp(i).*(maxKp - minKp);
%                 minKp
%                 mrizkaKp(i)
%                 maxKp
                %minKps
                PI = tf([origKp origKi],[1 0]);
        %         T = feedback(plant*PI,1);
        %         S = feedback(1,plant*PI);
                if(Ts)>0
                   PI = c2d(PI,Ts,'Tustin');
                end
        
                T = feedback(plant*PI,1);
                S = feedback(1,plant*PI);
                if (isstable(T)) == 1 && norm(S,inf)< Ms*1.01
                    %pocetReg = pocetReg+1;
                    %size(Kp)
                    %size(origKp)
                    %origKp
                    Kp(i) = origKp;
                    Ki(i) = origKi;
                end

            end
            
            
        end
    
        delete(w)
    




        Ki = Ki(~isinf(Ki));
        Kp = Kp(~isinf(Kp));
        
        
        hraniceIndex = boundary(Ki',Kp',0.1);
        
        
        %scatter(Ki,Kp)
        
        Region = [Ki',Kp'];

        hranicniBody = [Ki(hraniceIndex)',Kp(hraniceIndex)'];


end