function graf3D(tabulka,pozadavek)
    disp('Tvo se 3D graf')
    Sorted = sortrows(tabulka,[1 2],'ascend');
    [Kpi,Kpj] = unique(Sorted.Kp);
    [Kii,Kij] = unique(Sorted.Ki);
    maticeZZ = -inf*ones(length(Kpi)+1,length(Kii)+1);
    for i = 1:length(Kpj)-1
       for ii = 1:length(Kij) 
            for iii = Kpj(i):(Kpj(i+1)-1)
               if Kpi(i) == Sorted.Kp(iii) && Kii(ii) == Sorted.Ki(iii)
                   maticeZZ(i,ii) = Sorted.(pozadavek)(iii);
               end
            end
            for iii = Kpj(end):height(Sorted)
                if Kpi(i+1) == Sorted.Kp(iii) && Kii(ii) == Sorted.Ki(iii)
                   maticeZZ(i+1,ii) = Sorted.(pozadavek)(iii);
                end
            end

       end
    end

%     Kii = [Kii; max(Kii)+1/100*max(Kii)];
%     Kpi = [Kpi; max(Kpi)+1/100*max(Kpi)];
    
    
    nova_ZZ=-inf*ones(size(maticeZZ)+1);
    nova_ZZ(2:end,2:end)=maticeZZ;
    maticeZZ = nova_ZZ;
    
    Kii = [-1; Kii; max(Kii)+1/100*max(Kii)];
    Kpi = [-1; Kpi; max(Kpi)+1/100*max(Kpi)];
       
    [minHod,minInd]= min(Sorted.(pozadavek));
    zhod = mean(Sorted.(pozadavek));
    figure;
    surf(Kii,Kpi,maticeZZ);
    hold on
    scatter3(Sorted.Ki(minInd),Sorted.Kp(minInd),minHod*1.0001,'r','filled')
    %legend('pokus','minimum')
    text(Sorted.Ki(minInd),Sorted.Kp(minInd),zhod,['  minimum ' pozadavek],'interpreter', 'none','Color', 'red')
    xlabel('Ki');
    ylabel('Kp');
    zlabel(pozadavek);
    title(['Zvislost Ki a Kp na ' pozadavek],'interpreter', 'none')
    
end