%% pokus o interaktivitu
function interaktivniRegion(Tabulka,spolCast,Prd,Prd2,pozadavek)
    Tabulka = sortrows(Tabulka,pozadavek,'descend');
    f = figure;
    scatter(Tabulka.Ki(1),Tabulka.Kp(1),'r')
    hold on
    scatter(Tabulka.Ki(end),Tabulka.Kp(end),'b')
    legend(['maximum ' pozadavek],['minimum ' pozadavek],'AutoUpdate','off')

    cervena = [(0:floor(height(Tabulka)/2))./floor(height(Tabulka)/2), ones(1,ceil(height(Tabulka)/2)-1)];

    modra = zeros(1,height(Tabulka));
    zelena = [floor(height(Tabulka)/2)*ones(1,floor(height(Tabulka)/2)), (ceil(height(Tabulka)/2)-1):-1:0]./ceil(height(Tabulka)/2);

    
    scatter(Tabulka.Ki,Tabulka.Kp,5,[cervena', zelena', modra'],'filled')
%     for i = 1:height(Tabulka)
%         scatter(Tabulka.Ki(i),Tabulka.Kp(i),5,[Tabulka.barva(i) 0 0],'filled')
%         hold on
%     end
    hold on
     try
         while(true)
            [x,y] = ginput(1);

            % h = gco(); 
            % hx = h.XData; 
            % hy = h.YData; 

            hx = Tabulka.Ki;
            hy = Tabulka.Kp;


            d = sqrt((x-hx).^2 + (y-hy).^2); 
            [~,minIdx] = min(d); 

    %         fprintf('(x,y) = (%.3f,%.3f,%.3f)\n',hx(minIdx),hy(minIdx));

            Tab = vyber(Tabulka,'Ki',hx(minIdx)-1e-50,hx(minIdx)+1e-50);
            Tab = vyber(Tab,'Kp',hy(minIdx)-1e-50,hy(minIdx)+1e-50);

            vytvorGrafy(Tab,spolCast,Prd,Prd2)
%             if(exist('grafV','var'))
%                 [grafV,a,b,c,d] = vytvorGrafPres(Tab,spolCast,Prd,Prd2,1,grafV,a,b,c,d);
%             else
%                 [grafV,a,b,c,d] = vytvorGrafPres(Tab,spolCast,Prd,Prd2);
%             end
            figure(f)
            scatter(Tab.Ki,Tab.Kp,6,'k','s','filled')
            %figure;
            %(scatter(Tab.Ki,Tab.Kp))

         end
    catch
      disp('konec vbru')  
    end

%     function [grafV,a,b,c,d] = vytvorGrafPres(tabulka,spolCast,motor,zatez,spolCastZat,graf,a,b,c,d)
%     pokus = ~exist('graf','var');
%     if(~exist('graf','var'))
%         graf = figure();
%     end
%     if(~isvalid(graf))
%             graf = figure();
%     end
%     figure(graf)
%    
% 
%     if (~exist('motor', 'var'))
%         motor = 1;
%     end
% 
%     if (~exist('zatez', 'var'))
%         zatez = 1;
%     end
% 
%     if (~exist('spolCastZat', 'var'))
%         spolCastZat = spolCast;
%     end
%     Ts = Prd.Ts;
% i = 1;
% if(Ts>0)
%         PIc = (tf([tabulka.Kp(i) tabulka.Ki(i)],[1 0]));
%         PI(i) = c2d(PIc,Ts);
% else
%             PI(i) = (tf([tabulka.Kp(i) tabulka.Ki(i)],[1 0]));
% end
%         
%         Tm(i) = feedback(PI(i)*spolCast*motor,1);
%         Tl(i) = feedback(PI(i)*spolCastZat,motor)*zatez;
%         Psm(i) = feedback(spolCast*motor,PI(i));
%         Psl(i) = feedback(spolCastZat,motor*PI(i))*zatez;
% 
% 
%     if(~exist('a','var'))
%         a = subplot(2,2,1);
%     end
%         
%     if(~exist('b','var'))
%         b = subplot(2,2,2);
%     end
% 
%     if(~exist('c','var'))
%         c = subplot(2,2,3);
%     end
% 
%     if(~exist('d','var'))
%         d = subplot(2,2,4);
%     end
%         
%         
%     %a = subplot(2,2,1);
%     step(a,Tm)
%     hold(a,'on')
%     title('Pechodov charakteristika u motoru')
%     xlabel('Ki')
%     ylabel('Kp')
% 
%     step(b,Psm)
%     hold(b,'on')
%     %step(Psm)
%     %hold on
%     title('Odezva na poruchu u motoru')
%     xlabel('Ki')
%     ylabel('Kp')
% 
% 
%     step(c,Tl)
%     hold(c,'on')
%     %hold on
%     title('Pechodov charakteristika u zte')
%     xlabel('Ki')
%     ylabel('Kp')
%     
%     
%     
%     step(d,Psl)
%     hold(d,'on')
%     title('Odezva na poruchu u zte')
%     xlabel('Ki')
%     ylabel('Kp')
% 
%     grafV = graf;
% 
% 
% 
%     end
%     % legend()
%     

end   



