load('param_model.mat')

Ms = 2;
Ti = tf([0 3770 1.316e07],[0.33333 3771 1.316e07]);
integ = tf([0 1],[1 0]);

paralerni_vypocty = false;

tf2 = tf(tf2);
tf1 = tf(tf1);
%%
[hranicniBody, reg] = vypocetRegionu(Ti*tf1,Ms,paralerni_vypocty,true);

Region = hranicniBody{1};
%%
indexy = ["gm",'pm','sm','ym','yl','ITAE','itae_tl','itae_ps','itae_tl_ps','IAE','iae_tl','iae_ps','iae_tl_ps'];

Tabulka = vytvorTabulku(Region,Ms,paralerni_vypocty,Ti,tf1,tf2,indexy,4000);

%%
pozadavek1 = 'soucetITAE';
pozadavek2 = 'soucetITAE';
%%
Vyber = Tabulka;
Vyber.soucetITAE = Vyber.ITAE+Vyber.ITAE_Tl+Vyber.ITAE_PS+Vyber.ITAE_Tl_PS;
%Vyber.soucetIAE = Vyber.IAE+Vyber.IAE_Tl+Vyber.IAE_PS+Vyber.IAE_Tl_PS;
Vyber = vyber(Vyber,'Pm',60,inf);
Vyber = vyber(Vyber,'sm',0.5,inf);
Vyber = vyber(Vyber,'Gm',2,inf);
%Vyber = vyber(Vyber,'ym',0,1.1);
%Vyber = vyber(Vyber,'yl',0,1.1);



Vyber = vyberRegulatoru(Vyber,pozadavek1,pozadavek2,'min',1);


vytvorGrafy(Vyber,Ti,tf1,tf2)

%%

PI = tf([0.09595 2.71],[1 0])

Tab = vyhodnotRegulator(PI,Ti,tf1,tf2)

overGraf(PI,Ti,tf1,tf2)





%%
interaktivniRegion(Vyber,Ti,tf1,tf2,'IAE')


%% Namen data!

data = PDposdutest1(1:end,:);

cas = (data(:,1)-data(1,1));
data2 = data(:,2);
data3 = data(:,3);
data4 = data(:,4);
data5 = data(:,5);
data6 = data(:,6);
data7 = data(:,7);
data8 = data(:,8);
%data9 = data(:,9);

figure
%plot(cas,data9);
hold on
plot(cas,data4);
%poruch = data(:,5)./20+1.5;

figure
%plot(cas,data3);
%plot(cas,data5);
plot(cas,data3); %rychlost motoru
hold on
plot(cas,data7); %sp rychlost
plot(cas,data4); %rychlost trq
plot(cas,data6); %rychlost zateze
title('Rychlost pro PD reg')
% 
% figure
% %max(data2)
% 
% % % 
% plot(cas,data2)
% hold on
% 
% plot(cas,data5)
% plot(cas,data8)






figure
%max(data2)
%data2 = (data2-data2(1,1));
%data2 = data2./max(data2);
%max(data2)
% % 
plot(cas,data2)
hold on
%data5 = data5-data5(1,1);
%data5 = data5./max(data5);
%plot(cas,data5)
%plot(cas,data8)
%plot(cas,(data8-data8(1,1)))
title('Poloha pro PD reg')






%%

data = PIvel02(:,:);
cas = (data(:,1)-data(1,1));
data2 = data(:,2); %pozice motoru
data3 = data(:,3); %rychlost motoru
data4 = data(:,4); %chyba??
data5 = data(:,5); %pozice zateze
data6 = data(:,6); %rychlost zateze
data7 = data(:,7); %sp rychlost
data8 = data(:,8); %sp poloha

figure;
plot(cas,data5);
hold on
plot(cas,data2);
%%
%data = PIvel02(16.7*3.7822e+03:18*3.7822e+03,:);
%data = Ppos(19.150299*3.7822e+03:20*3.7822e+03,:);
%data = PDpos(0.31*6.9744e+03:1*6.9744e+03,:);
%data = PDpos;
data = PIvel02(:,:);
cas = (data(:,1)-data(1,1));
data2 = data(:,2)-data(1,2);
data3 = data(:,3);
data4 = data(:,4);
data5 = data(:,5)-data(1,5);
data6 = data(:,6);
data7 = data(:,7);
data8 = data(:,8)-data(1,8);


cas = (data(:,1)-data(1,1));
data9 = data(:,9);
%figure
% data6 = data6-data8(1,1);
% data3 = data3-data8(1,1);
% data8 = data8-data8(1,1);
% 
% 
% plot(cas,data8)
% hold on
% plot(cas,data6)
% plot(cas,data3)

%%



od = 299300;
do = 310000;
od = 0270250;
do = 0370000;
okamziky = od:do;


figure
subplot(2,2,1)
%plot(out.poz_hod.time(okamziky)-out.poz_hod.time(od),out.poz_hod.data(okamziky)+0);
%hold on
plot(cas,data8,'LineWidth',0.5)
hold on

plot(out.motor_rych.time(okamziky)-out.motor_pol.time(od),out.motor_pol.data(okamziky)+0,'LineWidth',0.5)
plot(cas,data2,'Color',[0 0.6 0])
xlim([0,1])
ylim([0,0.11])
title('Pechodov charakteristika motoru')
xlabel('as [s]')
ylabel('Amplituda')
legend('Poadovan','Simulovan','Reln','Location','best')

subplot(2,2,2)
plot(cas,data8,'LineWidth',0.5)
hold on
plot(out.zatez_pol.time(okamziky)-out.zatez_pol.time(od),out.zatez_pol.data(okamziky)+0,'LineWidth',0.5);
plot(cas,data5,'Color',[0 0.6 0])
xlim([0,1])
ylim([0,0.11])
title('Pechodov charakteristika zte')
xlabel('as [s]')
ylabel('Amplituda')
legend('Poadovan','Simulovan','Reln','Location','best')

%figure
 %hold on
%plot(cas,data8-14)
%plot(cas,data6-14)
%hold on
%plot(cas,data3-14)




data = PDpos(0.75*3.7822e+03:end,:);
%data = Ppos;
cas = (data(:,1)-data(1,1));
data2 = data(:,2)-data(1,2);
data3 = data(:,3);
data4 = data(:,4);
data5 = data(:,5)-data(1,5);
data6 = data(:,6);
data7 = data(:,7);
data8 = data(:,8)-data(1,8);


subplot(2,2,[3 4])
plot(cas,data8,'LineWidth',0.5)
hold on
plot(cas,data2,'LineWidth',0.5)
plot(cas,data5,'LineWidth',0.5,'Color',[0 0.6 0]);
xlim([0 30])
title('Prbh experimentu')
xlabel('as [s]')
ylabel('Amplituda')
sgtitle('Zkouka PD regultoru polohy')
legend('Poadovan','Motor','Zt','Location','best')



%%
data = PDpos(0.31*6.9744e+03:1*6.9744e+03,:);
cas = (data(:,1)-data(1,1));
data2 = data(:,2)-data(1,2);
data3 = data(:,3);
data4 = data(:,4);
data5 = data(:,5)-data(1,5);
data6 = data(:,6);
data7 = data(:,7);
data8 = data(:,8)-data(1,8);


figure
plot(cas,data7,'LineWidth',0.5)
hold on

plot(out.motor_rych.time(okamziky)-out.motor_rych.time(od),out.motor_rych.data(okamziky)+0,'LineWidth',0.5)
plot(cas,data3,'Color',[0 0.6 0]) %rychlost motoru
%xlim([0,1])
%ylim([0,0.11])
title('Pechodov charakteristika motoru')
xlabel('as [s]')
ylabel('Amplituda')
legend('Poadovan','Simulovan','Reln','Location','best')



%% Tvorba graf pro PI rychlost
%1. pechodovky!


data = PIvel02(16.5*3.7822e+03:18.5*3.7822e+03,:);
%data = Ppos(19.150299*3.7822e+03:20*3.7822e+03,:);
%data = PDpos(0.31*6.9744e+03:1*6.9744e+03,:);
%data = PDpos;
%data = PIvel02(:,:);
cas = (data(:,1)-data(1,1));
data2 = data(:,2)-data(1,2);
data3 = data(:,3);
data4 = data(:,4);
data5 = data(:,5)-data(1,5);
data6 = data(:,6);
data7 = data(:,7);
data8 = data(:,8)-data(1,8);


% cas = (data(:,1)-data(1,1));
% data9 = data(:,9);
%figure
% data6 = data6-data8(1,1);
% data3 = data3-data8(1,1);
% data8 = data8-data8(1,1);
% 
% 
% plot(cas,data8)
% hold on
% plot(cas,data6)
% plot(cas,data3)





%od = 400300;
%do = 510000;
od = 0246000;
do = 0370000;
okamziky = od:do;


figure
subplot(2,2,1)
%plot(out.poz_hod.time(okamziky)-out.poz_hod.time(od),out.poz_hod.data(okamziky)+0);
%hold on
plot(cas,data7-15,'LineWidth',0.75)
hold on

plot(out.motor_rych.time(okamziky)-out.motor_rych.time(od),out.motor_rych.data(okamziky)+0,'LineWidth',0.75)
plot(cas,data3-15,'Color',[0 0.6 0])
xlim([0,0.9])
%ylim([0,0.11])
title('Pechodov charakteristika motoru')
xlabel('as [s]')
ylabel('Amplituda')
legend('Poadovan','Simulovan','Reln','Location','best')

subplot(2,2,2)
plot(cas,data7-15,'LineWidth',0.75)
hold on
plot(out.zatez_rych.time(okamziky)-out.zatez_rych.time(od),out.zatez_rych.data(okamziky)+0,'LineWidth',0.75);
plot(cas,data6-15,'Color',[0 0.6 0])
xlim([0,0.9])
%ylim([0,0.11])
title('Pechodov charakteristika zte')
xlabel('as [s]')
ylabel('Amplituda')
legend('Poadovan','Simulovan','Reln','Location','best')


subplot(2,2,[3 4])

plot(out.moment_motor.time(okamziky)-out.moment_motor.time(od),out.moment_motor.data(okamziky)+0,'LineWidth',0.75,'Color', [0.8500, 0.3250, 0.0980]);
hold on
plot(cas,data4-0.1,'Color',[0 0.6 0])

xlim([0 0.9])
xlabel('as [s]')
title('Moment motoru - velikost aknho zsahu')
ylabel('Amplituda')
legend('Simulovan','Reln','Location','best')
sgtitle('Pechodov charakteristiky PI regultoru')

%% PI regultor - odregulovn poruch

data = PIvel02(36*3.7822e+03:37.5*3.7822e+03,:);
%data = Ppos(19.150299*3.7822e+03:20*3.7822e+03,:);
%data = PDpos(0.31*6.9744e+03:1*6.9744e+03,:);
%data = PDpos;
%data = PIvel02(:,:);
cas = (data(:,1)-data(1,1));
data2 = data(:,2)-data(1,2);
data3 = data(:,3);
data4 = data(:,4);
data5 = data(:,5)-data(1,5);
data6 = data(:,6);
data7 = data(:,7);
data8 = data(:,8)-data(1,8);
data9 = data(:,9);

% cas = (data(:,1)-data(1,1));
% data9 = data(:,9);
%figure
% data6 = data6-data8(1,1);
% data3 = data3-data8(1,1);
% data8 = data8-data8(1,1);
% 
% 
% plot(cas,data8)
% hold on
% plot(cas,data6)
% plot(cas,data3)





%od = 400300;
%do = 510000;
od = 0210675;
do = 0370000;
okamziky = od:do;


figure
subplot(2,2,1)
%plot(out.poz_hod.time(okamziky)-out.poz_hod.time(od),out.poz_hod.data(okamziky)+0);
%hold on
plot(cas,data7-15,'LineWidth',0.75)
hold on

plot(out.motor_rych.time(okamziky)-out.motor_rych.time(od),out.motor_rych.data(okamziky)+0,'LineWidth',0.75)
plot(cas,data3-15,'Color',[0 0.6 0])
xlim([0, 1])
%ylim([0,0.11])
title('Odezva na poruchu ze strany motoru')
xlabel('as [s]')
ylabel('Amplituda')
legend('Poadovan','Simulovan','Reln','Location','best')

subplot(2,2,2)
plot(cas,data7-15,'LineWidth',0.75)
hold on
plot(out.zatez_rych.time(okamziky)-out.zatez_rych.time(od),out.zatez_rych.data(okamziky)+0,'LineWidth',0.75);
plot(cas,data6-15,'Color',[0 0.6 0])
xlim([0 1])
%ylim([0,0.11])
title('Odezva na poruchu ze strany zte')
xlabel('as [s]')
ylabel('Amplituda')
legend('Poadovan','Simulovan','Reln','Location','best')


subplot(2,2,[3 4])
plot(cas,-data9,'LineWidth',0.75);
hold on
%plot(out.moment_porucha.time(okamziky)-out.moment_porucha.time(od),out.moment_porucha.data(okamziky)-0.1,'LineWidth',0.75);

plot(out.moment_motor.time(okamziky)-out.moment_motor.time(od),out.moment_motor.data(okamziky)+0.1,'LineWidth',0.75,'Color', [0.8500, 0.3250, 0.0980]);
hold on
plot(cas,data4-0.1,'Color',[0 0.6 0])

xlim([0 1])
xlabel('as [s]')
title('Moment motoru - velikost aknho zsahu + chyba momentu')
ylabel('Amplituda')
legend('Velikost poruchy','Simulovan','Reln','Location','best')
sgtitle('Odezva na poruchu PI regultor')




%% P regultor pechod



%data = PIvel02(16.5*3.7822e+03:18.5*3.7822e+03,:);
data = Ppos(3.9*3.7822e+03:5*3.7822e+03,:);
%data = PDpos(0.31*6.9744e+03:1*6.9744e+03,:);
%data = Ppos;
%data = PIvel02(:,:);
cas = (data(:,1)-data(1,1));
data2 = data(:,2)-data(1,2);
data3 = data(:,3);
data4 = data(:,4)+0.0647;
data5 = data(:,5)-data(1,5);
data6 = data(:,6);
data7 = data(:,7);
data8 = data(:,8)-data(1,8);


% cas = (data(:,1)-data(1,1));
% data9 = data(:,9);
%figure
% data6 = data6-data8(1,1);
% data3 = data3-data8(1,1);
% data8 = data8-data8(1,1);
% 
% 
% plot(cas,data8)
% hold on
% plot(cas,data6)
% plot(cas,data3)





%od = 400300;
%do = 510000;
od = 0486850;
do = 0570000;
okamziky = od:do;


figure
subplot(2,2,1)
%plot(out.poz_hod.time(okamziky)-out.poz_hod.time(od),out.poz_hod.data(okamziky)+0);
%hold on
plot(cas,data8,'LineWidth',0.75)
hold on

plot(out.motor_pol.time(okamziky)-out.motor_pol.time(od),out.motor_pol.data(okamziky)+0,'LineWidth',0.75)
plot(cas,data2,'Color',[0 0.6 0])
xlim([0,0.6])
ylim([0,0.11])
title('Pechodov charakteristika motoru')
xlabel('as [s]')
ylabel('Amplituda')
legend('Poadovan','Simulovan','Reln','Location','best')

subplot(2,2,2)
plot(cas,data8,'LineWidth',0.75)
hold on
plot(out.zatez_pol.time(okamziky)-out.zatez_pol.time(od),out.zatez_pol.data(okamziky)+0,'LineWidth',0.75);
plot(cas,data5,'Color',[0 0.6 0])
xlim([0,0.6])
ylim([0,0.11])
title('Pechodov charakteristika zte')
xlabel('as [s]')
ylabel('Amplituda')
legend('Poadovan','Simulovan','Reln','Location','best')


subplot(2,2,3)

% plot(out.moment_motor.time(okamziky)-out.moment_motor.time(od),out.moment_motor.data(okamziky)+0,'LineWidth',0.75,'Color', [0.8500, 0.3250, 0.0980]);
% hold on
% plot(cas,data4-0.1,'Color',[0 0.6 0])
plot(cas,data7);
hold on

plot(cas,data3)
plot(cas,data6,'Color',[0 0.6 0])

%xlim([0 0.9])
xlabel('as [s]')
title('Rychlost relnho')
ylabel('Amplituda')
legend('Poadovan rychlost','Rychlost motoru','Rychlost zte','Location','best')
xlim([0 0.6])

subplot(2,2,4)
%plot(out.moment_motor.time(okamziky)-out.moment_motor.time(od),out.moment_motor.data(okamziky)+0,'LineWidth',0.75,'Color', [0.8500, 0.3250, 0.0980]);

plot(out.poz_rychlost.time(okamziky)-out.poz_rychlost.time(od),out.poz_rychlost.data(okamziky));
hold on
plot(out.poz_rychlost.time(okamziky)-out.poz_rychlost.time(od),out.motor_rych.data(okamziky));
plot(out.poz_rychlost.time(okamziky)-out.poz_rychlost.time(od),out.zatez_rych.data(okamziky),'Color',[0 0.6 0]);
xlabel('as [s]')
title('Rychlost simulovanho')
ylabel('Amplituda')
legend('Poadovan rychlost','Rychlost motoru','Rychlost zte','Location','best')
xlim([0 0.6])


sgtitle('Pechodov charakteristiky P regultoru')




%% PD regulator prechod

%data = PIvel02(16.5*3.7822e+03:18.5*3.7822e+03,:);
data = PDpos(3.95*3.7822e+03:5*3.7822e+03,:);
%data = PDpos(0.31*6.9744e+03:1*6.9744e+03,:);
%data = Ppos;
%data = PIvel02(:,:);
cas = (data(:,1)-data(1,1));
data2 = data(:,2)-data(1,2);
data3 = data(:,3);
data4 = data(:,4)+0.0647;
data5 = data(:,5)-data(1,5);
data6 = data(:,6);
data7 = data(:,7);
data8 = data(:,8)-data(1,8);


% cas = (data(:,1)-data(1,1));
% data9 = data(:,9);
%figure
% data6 = data6-data8(1,1);
% data3 = data3-data8(1,1);
% data8 = data8-data8(1,1);
% 
% 
% plot(cas,data8)
% hold on
% plot(cas,data6)
% plot(cas,data3)





%od = 400300;
%do = 510000;
od = 0486500;
do = 0570000;
okamziky = od:do;


figure
subplot(2,2,1)
%%plot(out.poz_hod.time(okamziky)-out.poz_hod.time(od),out.poz_hod.data(okamziky)+0);

plot(cas,data8,'LineWidth',0.75)
hold on

plot(out.motor_pol.time(okamziky)-out.motor_pol.time(od),out.motor_pol.data(okamziky)+0,'LineWidth',0.75)
plot(cas,data2,'Color',[0 0.6 0])
xlim([0,0.6])
ylim([0,0.11])
title('Pechodov charakteristika motoru')
xlabel('as [s]')
ylabel('Amplituda')
legend('Poadovan','Simulovan','Reln','Location','best')



subplot(2,2,2)
plot(cas,data8,'LineWidth',0.75)
hold on
plot(out.zatez_pol.time(okamziky)-out.zatez_pol.time(od),out.zatez_pol.data(okamziky)+0,'LineWidth',0.75);
plot(cas,data5,'Color',[0 0.6 0])
xlim([0,0.6])
ylim([0,0.11])
title('Pechodov charakteristika zte')
xlabel('as [s]')
ylabel('Amplituda')
legend('Poadovan','Simulovan','Reln','Location','best')


subplot(2,2,3)

% plot(out.moment_motor.time(okamziky)-out.moment_motor.time(od),out.moment_motor.data(okamziky)+0,'LineWidth',0.75,'Color', [0.8500, 0.3250, 0.0980]);
% hold on
% plot(cas,data4-0.1,'Color',[0 0.6 0])
plot(cas,data7);
hold on

plot(cas,data3)
plot(cas,data6,'Color',[0 0.6 0])

%xlim([0 0.9])
xlabel('as [s]')
title('Rychlost relnho')
ylabel('Amplituda')
legend('Poadovan rychlost','Rychlost motoru','Rychlost zte','Location','best')
xlim([0 0.6])

subplot(2,2,4)
%plot(out.moment_motor.time(okamziky)-out.moment_motor.time(od),out.moment_motor.data(okamziky)+0,'LineWidth',0.75,'Color', [0.8500, 0.3250, 0.0980]);

plot(out.poz_rychlost.time(okamziky)-out.poz_rychlost.time(od),out.poz_rychlost.data(okamziky));
hold on
plot(out.poz_rychlost.time(okamziky)-out.poz_rychlost.time(od),out.motor_rych.data(okamziky));
plot(out.poz_rychlost.time(okamziky)-out.poz_rychlost.time(od),out.zatez_rych.data(okamziky),'Color',[0 0.6 0]);
xlabel('as [s]')
title('Rychlost simulovanho')
ylabel('Amplituda')
legend('Poadovan rychlost','Rychlost motoru','Rychlost zte','Location','best')
xlim([0 0.6])


sgtitle('Pechodov charakteristiky PD regultoru')









%% PD odezva na poruchu





data = PDposdutest(15*4.0000e+03:25*4.0000e+03,:);
cas = (data(:,1)-data(1,1));
data2 = data(:,2)-data(1,2);
data3 = data(:,3);
data4 = data(:,4)+0.0264;
data5 = data(:,5)-data(1,5);
data6 = data(:,6);
data7 = data(:,7);
data8 = data(:,8)-data(1,8);
data9 = data(:,9);


% cas = (data(:,1)-data(1,1));
% data9 = data(:,9);
%figure
% data6 = data6-data8(1,1);
% data3 = data3-data8(1,1);
% data8 = data8-data8(1,1);
% 
% 
% plot(cas,data8)
% hold on
% plot(cas,data6)
% plot(cas,data3)





%od = 400300;
%do = 510000;
od = 1;
do = 0970000;
okamziky = od:do;


figure
subplot(2,2,[1 2])
%%plot(out.poz_hod.time(okamziky)-out.poz_hod.time(od),out.poz_hod.data(okamziky)+0);

plot(cas,data8,'LineWidth',0.75)
hold on

plot(out.motor_pol.time(okamziky)-out.motor_pol.time(od),out.motor_pol.data(okamziky)+0,'LineWidth',0.75)
plot(cas,data2,'Color',[0 0.6 0])
xlim([0,9.8])
%ylim([0,0.11])
title('Odezva na poruchu na stran motoru')
xlabel('as [s]')
ylabel('Amplituda')
legend('Poadovan','Simulovan','Reln','Location','best')



% subplot(2,2,2)
% plot(cas,data8,'LineWidth',0.75)
% hold on
% plot(out.zatez_pol.time(okamziky)-out.zatez_pol.time(od),out.zatez_pol.data(okamziky)+0,'LineWidth',0.75);
% plot(cas,data5,'Color',[0 0.6 0])
% %xlim([0,0.6])
% %ylim([0,0.11])
% title('Pechodov charakteristika zte')
% xlabel('as [s]')
% ylabel('Amplituda')
% legend('Poadovan','Simulovan','Reln','Location','best')


subplot(2,2,[3 4])

% plot(out.moment_motor.time(okamziky)-out.moment_motor.time(od),out.moment_motor.data(okamziky)+0,'LineWidth',0.75,'Color', [0.8500, 0.3250, 0.0980]);
% hold on
% plot(cas,data4-0.1,'Color',[0 0.6 0])
plot(cas,-data9);
hold on
plot(out.moment_motor.time(okamziky)-out.moment_motor.time(od),out.moment_motor.data(okamziky)+0,'LineWidth',0.75,'Color', [0.8500, 0.3250, 0.0980]);
plot(cas,data4,'Color',[0 0.6 0])
%plot(out.moment_motor.time(okamziky)-out.moment_motor.time(od),out.motor_rych.data(okamziky)+0,'LineWidth',0.75,'Color', [0.8500, 0.3250, 0.0980]);



%xlim([0 0.9])
xlabel('as [s]')
title('Moment relnho motoru')
ylabel('Amplituda')
legend('Velikost poruchy','Moment motoru simulovan','Moment motoru skuten','Location','best')
%xlim([0 0.6])
xlim([0,9.8])

sgtitle('Odezva na poruchu PD regultor')









%% odezva na Poruchu P reg



data = Pposdutest(7*4.0000e+03:24*4.0000e+03,:);
cas = (data(:,1)-data(1,1));
data2 = data(:,2)-data(1,2);
data3 = data(:,3);
data4 = data(:,4)-0.0616;
data5 = data(:,5)-data(1,5);
data6 = data(:,6);
data7 = data(:,7);
data8 = data(:,8)-data(1,8);
data9 = data(:,9);


% cas = (data(:,1)-data(1,1));
% data9 = data(:,9);
%figure
% data6 = data6-data8(1,1);
% data3 = data3-data8(1,1);
% data8 = data8-data8(1,1);
% 
% 
% plot(cas,data8)
% hold on
% plot(cas,data6)
% plot(cas,data3)





%od = 400300;
%do = 510000;
od = 1;
do = 1500000;
okamziky = od:do;


figure
subplot(2,2,[1 2])
%%plot(out.poz_hod.time(okamziky)-out.poz_hod.time(od),out.poz_hod.data(okamziky)+0);

plot(cas,data8,'LineWidth',0.75)
hold on

plot(out.motor_pol.time(okamziky)-out.motor_pol.time(od),out.motor_pol.data(okamziky)+0,'LineWidth',0.75)
plot(cas,data2,'Color',[0 0.6 0])
%xlim([0,9.8])
%ylim([0,0.11])
title('Odezva na poruchu na stran motoru')
xlabel('as [s]')
ylabel('Amplituda')
legend('Poadovan','Simulovan','Reln','Location','best')



% subplot(2,2,2)
% plot(cas,data8,'LineWidth',0.75)
% hold on
% plot(out.zatez_pol.time(okamziky)-out.zatez_pol.time(od),out.zatez_pol.data(okamziky)+0,'LineWidth',0.75);
% plot(cas,data5,'Color',[0 0.6 0])
% %xlim([0,0.6])
% %ylim([0,0.11])
% title('Pechodov charakteristika zte')
% xlabel('as [s]')
% ylabel('Amplituda')
% legend('Poadovan','Simulovan','Reln','Location','best')


subplot(2,2,[3 4])

% plot(out.moment_motor.time(okamziky)-out.moment_motor.time(od),out.moment_motor.data(okamziky)+0,'LineWidth',0.75,'Color', [0.8500, 0.3250, 0.0980]);
% hold on
% plot(cas,data4-0.1,'Color',[0 0.6 0])
plot(cas,-data9);
hold on
plot(out.moment_motor.time(okamziky)-out.moment_motor.time(od),out.moment_motor.data(okamziky)+0,'LineWidth',0.75,'Color', [0.8500, 0.3250, 0.0980]);
plot(cas,data4,'Color',[0 0.6 0])
%plot(out.moment_motor.time(okamziky)-out.moment_motor.time(od),out.motor_rych.data(okamziky)+0,'LineWidth',0.75,'Color', [0.8500, 0.3250, 0.0980]);



%xlim([0 0.9])
xlabel('as [s]')
title('Moment relnho motoru')
ylabel('Amplituda')
legend('Velikost poruchy','Moment motoru simulovan','Moment motoru skuten','Location','best')
%xlim([0 0.6])
%xlim([0,9.8])

sgtitle('Odezva na poruchu P regultor')



















function Tabulka = vyhodnotRegulator(PI,spolCast,Prd,Prd2)
    F0 = spolCast*Prd*PI;
    T = feedback(PI*spolCast*Prd,1);
    Tl = feedback(PI*spolCast,Prd)*Prd2;
    S = feedback(1,PI*spolCast*Prd);
    %disp('Tady')
    [Gm,Pm] = margin(F0);
    sirka_pasma = bandwidth(T);
    sm = 1/norm(S,inf);
    max_hod_T = (max(step(T)));
    max_hod_Tl =(max(step(Tl)));

    Tabulka = table(Gm,Pm,sm,sirka_pasma,max_hod_T,max_hod_Tl);

end

function overGraf(PI,spolCast,Prd,Prd2)
    T = feedback(PI*spolCast*Prd,1);
    Tl = feedback(PI*spolCast,Prd)*Prd2;
    
    
    
    Psm = feedback(spolCast*Prd,PI);
    Psl = feedback(spolCast,Prd*PI)*Prd2;
    

    figure
    subplot(1,2,2)
    step(T)
    hold on
    step(Tl)
    legend('motor','zt')
    title('Pechodov charakteristika')

   
    subplot(1,2,1)
    step(Psm)
    %bode(T);
    hold on
    %bode(Tl)
    step(Psl)
    legend('motor','zt')
    title('Vstupn porucha')
    
end

function overGrafRychl(C,sDerUz,Prd,Prd2,integd,P,spolCastPol) %P,sDerUz,Prd*integd,Prd2*integd,D,spolCastPol
    
    Tp = feedback(C*spolCastPol*Prd*integd,1);
    Tlp = feedback(C*spolCastPol,Prd*integd)*Prd2*integd;
    
    
    
    Tpd = feedback(P*sDerUz*Prd*integd,1);
    Tlpd = feedback(P*sDerUz,Prd*integd)*Prd2*integd;
    
    
    
    
    

    figure
    subplot(1,2,2)
    step(Tp)
    hold on
    step(Tlp)
    legend('motor','zt')
    title('P regultor')

   
    subplot(1,2,1)
    step(Tpd)
    %bode(T);
    hold on
    step(Tlpd)
    %step(Psl)
    legend('motor','zt')
    title('PD regultor')
    
end


